/*****************************************************************************/
/** File    : center.c                                                      **/
/** Purpose : popup a widget over the center of the application             **/
/** Authors : M.L. Drillaud V. Lataste L. Pringot T. Ramiere J.L. Richard   **/
/** Date    : 1st Mar 1992                                                  **/
/*****************************************************************************/
#include "xproc.h"

#include "interface.h"

void Realize_Center (Widget popup)
{
  /* pop popup widget with the center of the popup 
     over the center of the application.   */
  
  Position x,y;
  Dimension appWidth, appHeight, qWidth, qHeight;
  XtGeometryResult result;
  XtWidgetGeometry answer, question;
  
  Arg arglist[2];

  XtRealizeWidget (popup);

  /* Get dimensions of application */

  XtSetArg (arglist[0], XtNwidth,   &appWidth);
  XtSetArg (arglist[1], XtNheight, &appHeight);
  XtGetValues (w_main.itself, arglist, 2);
  
  /* Get dimensions of quit popup */
  
  XtSetArg (arglist[0], XtNwidth,   &qWidth); 
  XtSetArg (arglist[1], XtNheight, &qHeight);
  XtGetValues (popup, arglist, 2);
  
  /* Translate application coordinates to screen coordinates */
  XtTranslateCoords (toplevel,
		     (Position) ((appWidth/2)-(qWidth/2)),
		     (Position) ((appHeight/2)-(qHeight/2)),
		     &x, &y);
  
  /* move popup shell to that position */
  
  XtSetArg (arglist[0], XtNx,  x);
  XtSetArg (arglist[1], XtNy,  y);
  XtSetValues (popup, arglist, 2);

  XtPopup (popup, XtGrabNonexclusive);
}

