/*****************************************************************************/
/** File    : give_ps.c                                                     **/
/** Purpose : give the list of the processes of an user on a host           **/
/** Authors : M.L. Drillaud V. Lataste L. Pringot T. Ramiere J.L. Richard   **/
/** Date    : 1st Mar 1992                                                  **/
/*****************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <errno.h>
#include "structure.h"
#include "defines.h"
#include "dqueue.h"

extern int Read_nb(int,
		   char *,
		   struct sockaddr_in *);               /* From manip_sock.c */
extern int Receive_struct_host(int (*)(),
			       int,struct sockaddr_in *,
			       struct host_ps *);       /* From manip_host.c */
extern int Execute(int,char *,char *,dqueue);           /* From execute.c */
extern void * Our_alloc(long);                          /* From our_alloc.c */

extern dqueue empty_queue;


int Give_ps(int sock,
	    char *host_name,
	    struct host_ps * structure_host)
{
  /* Give the list of processes on 'host_name'. 
     Used by the interface. 
     Return value : 0 if successful, -1 otherwise. */

  int res_command;
  char *no_trouble;

  no_trouble=(char *)Our_alloc(3);
  *no_trouble=0;
  res_command=Execute(sock,host_name,"XGIVE_PS",empty_queue);
  if (res_command == 0){
    while((*no_trouble == 0) && (errno == 0))
      Read_nb(sock,no_trouble,NULL);
    if (atoi(no_trouble) == 0)
      
      /* Ready to receive the structure from the daemon. */
      res_command=Receive_struct_host(Read_nb,sock,NULL,structure_host);
    else
      res_command=-1;
  }
  return res_command;
}
