/*****************************************************************************/
/** File    : main.c                                                        **/
/** Purpose : initialize socket and application                             **/
/** Authors : M.L. Drillaud V. Lataste L. Pringot T. Ramiere J.L. Richard   **/
/** Date    : 1st Mar 1992                                                  **/
/*****************************************************************************/
/* Copyright 1992 DESS Genie Logiciel */

#include "xproc.h"

#include <sys/socket.h>
#include "defines.h"

#include "structure.h"
#include "interface.h"

extern void Initialize (int,String **); /* init_resour.c */
extern void Create_host_ps_struct (); /* list.c */
extern int Create_sock_UNIX (struct sockaddr *,String );
extern int Connect_daemon (int,struct sockaddr *); 
extern void Create_Main_Interface (); /* main_interfa.c */

int sock;

main (int argc, String * argv[])
{
  struct sockaddr ad_sock;	
  nb_w_ps = 0;

  empty_queue=dq_create(); 

  Initialize (argc,argv); 

  Create_host_ps_struct (); 

  sock = Create_sock_UNIX (&ad_sock,OUR_SOCKET_UNIX);
  if(Connect_daemon (sock,&ad_sock)==-1)
    {
      fprintf(stderr,"Error: connexion trouble with daemon. \n"); 
      End_connect(sock);
      exit(-1);
    }
  Create_Main_Interface(); 
  XtAppMainLoop (app_con);
}

void *Our_XtMalloc(long size)
{
  void *res;
  
  if ((res=(void *)XtMalloc(size)) == NULL)
    {
      fprintf(stderr,"Can't allocate memory!\nFatal error.\n");
      End_connect(sock);
      XrmDestroyDatabase(db_xproc);
      XtDestroyApplicationContext (app_con);
      exit (-1);
    }
  return res;
}









