/*****************************************************************************/
/** File    : problem.c                                                     **/
/** Purpose : create, map and unmap a widget when trouble with deamon       **/
/** Authors : M.L. Drillaud V. Lataste L. Pringot T. Ramiere J.L. Richard   **/
/** Date    : 1st Mar 1992                                                  **/
/*****************************************************************************/
#include "xproc.h"

#include <sys/param.h>

#include <X11/Xaw/Command.h>
#include <X11/Shell.h>
 
#include "interface.h"
#include "structure.h"
#include "Xedw/XedwList.h"

extern void Close_Host (Widget, XButtonEvent*); /* actions.c */
extern window_type * Goto_window_host (String ); /* goto.c */
extern XedwList ** Modiflist_icon 
  (Widget,String ,Pixmap,Pixmap,int); /* modif_icon.c */
extern struct icon_name * Goto_struct ( dqueue, String ); /* goto.c */
extern void * Our_XtMalloc(long); /* main.c */

extern int Nb_struct (dqueue);

Widget w_pb;

void Close_pb_w (Widget w, XtPointer client_data, XtPointer call_data)
{
  /* close problem window when its clicked */

  window_type * host;

  XtPopdown (w_pb);
  host=Goto_window_host(client_data);
  if(host!=NULL) /* is Widget Host exist ? */
    XtPopdown ((Goto_window_host ((String )client_data))->toplevel);
      /* unmask host icon named client_data in Host XedwList */
      XedwListChange (w_main.host.list.itself,
		      Modiflist_icon (w_main.host.list.itself, 
				      (String )client_data,
				      StringtoPixmap ((Goto_struct (config_list[Host],(String )client_data))->icon),
				      0,
				      GXcopy),
		      Nb_struct (config_list[Host]),
		      0,
		      True);
}

void Problem_w (String hostname)
{
  /* create trouble window over the center of the application */
  /* User must be click in to close this window */

  Widget w_pb_command;
  Arg arglist[1];
  String ProblemLabel;
  
  ProblemLabel = (String)Our_XtMalloc (sizeof(char)*(25+MAXHOSTNAMELEN));
  sprintf (ProblemLabel,"\n trouble with %s \n\n",hostname);
  w_pb = 
    XtCreatePopupShell ("Problem",
			overrideShellWidgetClass,
			w_main.itself,
			NULL, ZERO);
  
  XtSetArg (arglist[0], XtNlabel, ProblemLabel); 
  
  w_pb_command  =   
    XtCreateManagedWidget (NULL,
			   commandWidgetClass,
			   w_pb,
			   arglist, 1);
  XtAddCallback (w_pb_command, XtNcallback, Close_pb_w, hostname);
  Realize_Center (w_pb); /* center Widget */
} 





